Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/description/ComputingResourceDescription.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/description/ComputingResourceDescription.java	(revision 1113)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/description/ComputingResourceDescription.java	(revision 1207)
@@ -1,49 +1,28 @@
 package schedframe.resources.computing.description;
 
-import java.io.FileInputStream;
-import java.io.FileNotFoundException;
-import java.io.IOException;
 import java.util.ArrayList;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.Iterator;
 import java.util.List;
-import java.util.PropertyResourceBundle;
-import java.util.ResourceBundle;
+import java.util.Map;
 
-import schedframe.Parameter;
 import schedframe.Parameters;
-import schedframe.Property;
 import schedframe.resources.ResourceTypeFactory;
-import schedframe.resources.computing.location.Location;
-import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputProfile;
-import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputState;
-import schedframe.resources.computing.profiles.energy.airthroughput.plugin.AirThroughputEstimationPlugin;
-import schedframe.resources.computing.profiles.energy.airthroughput.plugin.DefaultAirThroughputEstimationPlugin;
-import schedframe.resources.computing.profiles.energy.power.PState;
-import schedframe.resources.computing.profiles.energy.power.PowerProfile;
-import schedframe.resources.computing.profiles.energy.power.PowerState;
-import schedframe.resources.computing.profiles.energy.power.PowerStateNameFactory;
-import schedframe.resources.computing.profiles.energy.power.Transition;
-import schedframe.resources.computing.profiles.energy.power.plugin.EnergyEstimationPlugin;
-import schedframe.resources.computing.profiles.energy.thermal.ThermalProfile;
-import schedframe.resources.computing.profiles.energy.thermal.plugin.DefaultTemperatureEstimationPlugin;
-import schedframe.resources.computing.profiles.energy.thermal.plugin.TemperatureEstimationPlugin;
+import schedframe.resources.devices.Device;
+import schedframe.resources.devices.description.DeviceDescription;
+import schedframe.resources.devices.description.PhysicalResourceDescription;
 import schedframe.resources.units.ResourceUnit;
 import schedframe.resources.units.ResourceUnitFactory;
+import schedframe.resources.units.ResourceUnitName;
 import schedframe.resources.utils.ResourceIdGenerator;
 import schemas.ComputingResource;
-import schemas.PowerUsage;
-import schemas.Profile;
-import simulator.utils.InstanceFactory;
-import example.energy.DefaultEnergyEstimationPlugin;
 
-public class ComputingResourceDescription extends ExecutingResourceDescription {
 
-	//protected Map<ResourceUnitName, List<AbstractResourceUnit>> resUnits;
-	protected PowerProfile powerProfile;
-	protected AirThroughputProfile airThroughputProfile;
-	protected ThermalProfile thermalProfile;
-	protected Location location;
-	protected String category;
-	//protected Parameters parameters;
+public class ComputingResourceDescription extends PhysicalResourceDescription implements ExecutingResourceDescription {
 
+	protected Map<ResourceUnitName, List<ResourceUnit>> resUnits;
+	protected List<Device> devices;
+	
 	public ComputingResourceDescription(ComputingResource computingResource) {
 
@@ -55,25 +34,8 @@
 		if (computingResource.getComputingResourceTypeChoiceSequence() != null) {
 			initResourceUnits(computingResource.getComputingResourceTypeChoiceSequence().getResourceUnit());
-			try {
-				if(System.getProperty("coolemall.resdesc") != null){
-					schemas.EnergyEstimationPlugin eep = new schemas.EnergyEstimationPlugin();
-					eep.setName(getEEP(createEEPQuery(computingResource), System.getProperty("coolemall.resdesc")));
-					if(computingResource.getComputingResourceTypeChoiceSequence().getProfile() != null) {
-						if(computingResource.getComputingResourceTypeChoiceSequence().getProfile().getPowerProfile() != null) {
-							computingResource.getComputingResourceTypeChoiceSequence().getProfile().getPowerProfile().setEnergyEstimationPlugin(eep);
-						}
-					} else {
-						schemas.Profile p = new schemas.Profile();
-						computingResource.getComputingResourceTypeChoiceSequence().setProfile(p);
-						schemas.PowerProfile pp = new schemas.PowerProfile();
-						computingResource.getComputingResourceTypeChoiceSequence().getProfile().setPowerProfile(pp);
-						computingResource.getComputingResourceTypeChoiceSequence().getProfile().getPowerProfile().setEnergyEstimationPlugin(eep);
-					}
-				}
-			} catch (FileNotFoundException e) {
-			} catch (IOException e) {
-			}
+
 			initProfiles(computingResource.getComputingResourceTypeChoiceSequence().getProfile());
 			initLocation(computingResource.getComputingResourceTypeChoiceSequence().getLocation());
+			initDevices(computingResource.getComputingResourceTypeChoiceSequence().getDevice());
 			this.parameters = extractParameters(computingResource.getComputingResourceTypeChoiceSequence().getParameter());
 		}
@@ -97,164 +59,18 @@
 		}
 	}
-
-	private void initProfiles(Profile profile) {
-		if (profile != null) {
-			initPowerProfile(profile.getPowerProfile());
-			initAirThroughputProfile(profile.getAirThroughputProfile());
-			initThermalProfile(profile.getThermalProfile());
-		}
-	}
 	
-	private void initPowerProfile(schemas.PowerProfile powerProfileCharacteristic) {
-		
-		if (powerProfileCharacteristic != null) {
-			EnergyEstimationPlugin energyEstimationPlugin = null;
-			List<PowerState> powerStates = null;
-			List<PState> pStates = null;
-			if(powerProfileCharacteristic.getEnergyEstimationPlugin() != null){
-				String energyEstimationPluginName = powerProfileCharacteristic.getEnergyEstimationPlugin().getName();
-				if(energyEstimationPluginName != null) {
-					energyEstimationPlugin = (EnergyEstimationPlugin) InstanceFactory.createInstance(
-							energyEstimationPluginName, EnergyEstimationPlugin.class);			
-				} else {
-					energyEstimationPlugin = new DefaultEnergyEstimationPlugin();
-				}
-				Parameters params = extractParameters(powerProfileCharacteristic.getEnergyEstimationPlugin().getParameter());
-				energyEstimationPlugin.init(params);
+	private void initDevices(schemas.Device[] dev) {
+		if (dev != null){
+			this.devices = new ArrayList<Device>();
+			for(int i = 0; i < dev.length; i++){
+				Device device = new Device(new DeviceDescription(dev[i]));
+				this.devices.add(device);
 			}
-			
-			if(powerProfileCharacteristic.getPowerStates() != null) {
-				powerStates = new ArrayList<PowerState>();
-				int powerStateCount = powerProfileCharacteristic.getPowerStates().getPowerStateCount();
-				for (int i = 0; i < powerStateCount ; i++) {
-					schemas.PowerState ps = powerProfileCharacteristic.getPowerStates().getPowerState(i);
-					List<Transition> transitions = new ArrayList<Transition>();
-					int transitionCount = ps.getTransitionCount();
-					for (int j = 0; j < transitionCount; j++) {
-						schemas.Transition t = ps.getTransition(j);
-						Transition transition = new Transition(PowerStateNameFactory.createPowerStateName(t.getTo()), t
-								.getPowerUsage().getContent(), t.getTime().getContent());
-						Parameters params = extractParameters(t.getParameter());
-						transition.init(params);
-						transitions.add(transition);
-					}
-					//CoolEmAll DEBB description case
-					if(ps.getPowerUsage() == null){
-						ps.setPowerUsage(new PowerUsage("0"));
-					}
-					PowerState powerState = new PowerState(PowerStateNameFactory.createPowerStateName(ps.getName()), ps
-							.getPowerUsage().getContent(), transitions);
-					Parameters params = extractParameters(ps.getParameter());
-					powerState.init(params);
-					powerStates.add(powerState);
-				}
-			}
-			
-			if(powerProfileCharacteristic.getParameter() != null){
-				pStates = new ArrayList<PState>();
-				int parameterCount = powerProfileCharacteristic.getParameterCount();
-				for(int i = 0; i < parameterCount; i++){
-					schemas.Parameter parameter = powerProfileCharacteristic.getParameter(i);
-					if(parameter.getName().equals("pState")){
-						PState.Builder builder = new PState.Builder();
-						int propertyCount = parameter.getParameterTypeSequence().getPropertyCount();
-						for(int j = 0; j < propertyCount; j++){
-							schemas.Property property = parameter.getParameterTypeSequence().getProperty(j);
-							if(property.getName().equals("name")){
-								 builder = builder.name(property.getStringValueWithUnit(0).getContent());
-							} else if (property.getName().equals("frequency")){
-								 builder = builder.frequency(Double.valueOf(property.getStringValueWithUnit(0).getContent()));
-							} else if (property.getName().equals("voltage")){
-								builder = builder.voltage(Double.valueOf(property.getStringValueWithUnit(0).getContent()));
-							} else if (property.getName().equals("powerUsage")){
-								if(property.getStringValueWithUnit(0).getContent() != null && property.getStringValueWithUnit(0).getContent().length() > 0){
-									builder = builder.powerUsage(Double.valueOf(property.getStringValueWithUnit(0).getContent()));	
-								}
-							} else if (property.getName().equals("powerUsageMin")){
-								if(property.getStringValueWithUnit(0).getContent() != null && property.getStringValueWithUnit(0).getContent().length() > 0){
-									builder = builder.powerUsageMin(Double.valueOf(property.getStringValueWithUnit(0).getContent()));	
-								}
-							} else if (property.getName().equals("powerUsageMax")){
-								if(property.getStringValueWithUnit(0).getContent() != null && property.getStringValueWithUnit(0).getContent().length() > 0){
-									builder = builder.powerUsageMax(Double.valueOf(property.getStringValueWithUnit(0).getContent()));	
-								}
-							}
-						}
-						PState pState = builder.build();
-						pStates.add(pState);
-					}
-				}	
-			}
-			this.powerProfile = new PowerProfile(energyEstimationPlugin, powerStates, pStates);
-			Parameters params = extractParameters(powerProfileCharacteristic.getParameter());
-			this.powerProfile.init(params);
 		}
 	}
 
-	private void initAirThroughputProfile(schemas.AirThroughputProfile airThroughputProfile) {
-		if (airThroughputProfile != null) {
-			
-			AirThroughputEstimationPlugin airThroughputEstimationPlugin = null;
-			List<AirThroughputState> airThroughputStates = null;
-			if(airThroughputProfile.getAirThroughputEstimationPlugin() != null){
-				String airThroughputEstimationPluginName = airThroughputProfile.getAirThroughputEstimationPlugin().getName();
-				if(airThroughputEstimationPluginName != null) {
-					airThroughputEstimationPlugin = (AirThroughputEstimationPlugin) InstanceFactory.createInstance(
-							airThroughputEstimationPluginName, AirThroughputEstimationPlugin.class);			
-				} else {
-					airThroughputEstimationPlugin = new DefaultAirThroughputEstimationPlugin();
-				}
-				Parameters params = extractParameters(airThroughputProfile.getAirThroughputEstimationPlugin().getParameter());
-				airThroughputEstimationPlugin.init(params);
-			}
-			if(airThroughputProfile.getAirThroughputStates() != null){
-				airThroughputStates = new ArrayList<AirThroughputState>();
-				int airThrouhputStateCount = airThroughputProfile.getAirThroughputStates().getAirThroughputStateCount();
-				for (int i = 0; i < airThrouhputStateCount; i++) {
-					schemas.AirThroughputState ats = airThroughputProfile.getAirThroughputStates().getAirThroughputState(i);
-					AirThroughputState airThroughputState = new AirThroughputState(ats.getName(), ats.getValue()
-							.getContent(), ats.getPowerUsage().getContent());
-					Parameters params = extractParameters(ats.getParameter());
-					airThroughputState.init(params);
-					airThroughputStates.add(airThroughputState);
-				}
-			}
-			this.airThroughputProfile = new AirThroughputProfile(airThroughputEstimationPlugin, airThroughputStates);
-			Parameters params = extractParameters(airThroughputProfile.getParameter());
-			this.airThroughputProfile.init(params);
-		}
+	public String getCompResourceParameterValue(String name){
+		return getParameters().get(name).get(0).getContent();
 	}
-	
-	private void initThermalProfile(schemas.ThermalProfile thermalProfile) {
-		
-		if (thermalProfile != null) {
-			
-			TemperatureEstimationPlugin temperatureEstimationPlugin = null;
-
-			if(thermalProfile.getTemperatureEstimationPlugin() != null){
-				String temperatureEstimationPluginName = thermalProfile.getTemperatureEstimationPlugin().getName();
-				if(temperatureEstimationPluginName != null) {
-					temperatureEstimationPlugin = (TemperatureEstimationPlugin) InstanceFactory.createInstance(
-							temperatureEstimationPluginName, TemperatureEstimationPlugin.class);			
-				} else {
-					temperatureEstimationPlugin = new DefaultTemperatureEstimationPlugin();
-				}
-				Parameters params = extractParameters(thermalProfile.getTemperatureEstimationPlugin().getParameter());
-				temperatureEstimationPlugin.init(params);
-			}
-			this.thermalProfile = new ThermalProfile();
-			Parameters params = extractParameters(thermalProfile.getParameter());
-			this.thermalProfile.init(params);
-		}
-	}
-	
-	private void initLocation(schemas.Location l) {
-		if (location != null) {
-			this.location = new Location(l.getHorizontal(), l.getVertical(), l.getDepth());
-			Parameters params = extractParameters(l.getParameter());
-			this.location.init(params);
-		}
-	}
-
 
 	/*private Properties initProperties(schemas.Parameter[] parameters){
@@ -285,78 +101,52 @@
 		return prop;
 	}*/
-	
-	private Parameters extractParameters(schemas.Parameter[] parameters){
-		
-		Parameters params = null;
-		
-		if(parameters.length != 0)
-			params = new Parameters();
-		
-		for(int i = 0; i < parameters.length; i++){
-			schemas.Parameter parameter = parameters[i];
-			Parameter param = new Parameter(parameter.getName());
-			if(parameter.getParameterTypeSequence() != null && parameter.getParameterTypeSequence().getProperty() != null)
-			{							
-				int propertyCount = parameter.getParameterTypeSequence().getPropertyCount();
-				for(int j = 0; j < propertyCount; j++){
-					schemas.Property property = parameter.getParameterTypeSequence().getProperty(j);
-					Property prop = new Property(property.getName());
-					int stringValueWithUnitCount = property.getStringValueWithUnitCount();
-					for(int k = 0; k < stringValueWithUnitCount; k++){
-						prop.add(property.getStringValueWithUnit(k));
-					}
-					param.addProperty(prop);
-				}
-			} else {
-				int stringValueWithUnitCount =  parameter.getStringValueWithUnitCount();
-				for(int j = 0; j < stringValueWithUnitCount; j++){
-					param.add(parameter.getStringValueWithUnit(j));
-				}
-			}
-			params.put(parameter.getName(), param);
-		}
-		return params;
-	}
 
-	public PowerProfile getPowerProfile() {
-		return powerProfile;
-	}
 
-	public AirThroughputProfile getAirThroughputProfile() {
-		return airThroughputProfile;
-	}
-
-	public ThermalProfile getThermalProfile() {
-		return thermalProfile;
-	}
-	
-	public Location getLocation() {
-		return location;
-	}
-
-	public String getCategory() {
-		return category;
+	public List<Device> getDevices() {
+		return devices;
 	}
 
 
-	/***COOLEMALL CASE RELATED***/
-
-	private static ResourceBundle recsBundle;
-	
-	private ResourceBundle getRecsBundle(String fileName) throws FileNotFoundException, IOException{
-		if(recsBundle == null){
-			recsBundle = new PropertyResourceBundle(new FileInputStream(fileName));
+	public void addResourceUnit(ResourceUnit unit) {
+		if (this.resUnits == null)
+			this.resUnits = new HashMap<ResourceUnitName, List<ResourceUnit>>(1);
+		List<ResourceUnit> list = null;
+		if (this.resUnits.containsKey(unit.getName())) {
+			list = this.resUnits.get(unit.getName());
+		} else {
+			list = new ArrayList<ResourceUnit>(1);
+			this.resUnits.put(unit.getName(), list);
 		}
-		return recsBundle;
+		list.add(unit);
 	}
 	
-	protected String getEEP(String query, String fileName) throws FileNotFoundException, IOException{
-		ResourceBundle recsBundle = getRecsBundle(fileName);
-		return recsBundle.getString(query);
+	public ResourceUnit getResourceUnit(ResourceUnitName unitName) throws NoSuchFieldException {
+		return getResourceUnitList(unitName).get(0);
 	}
-	
-	protected String createEEPQuery(ComputingResource compRes) {
-		String query = compRes.getClazz() + "EEP";
-		return query;
+
+	public List<ResourceUnit> getResourceUnitList(ResourceUnitName unitName) throws NoSuchFieldException {
+		if (resUnits.containsKey(unitName))
+			return resUnits.get(unitName);
+		else
+			throw new NoSuchFieldException("Resource unit " + unitName + " is not available in resource " + this.id);
+	}
+
+	public Collection<ResourceUnit> getResourceUnit() {
+		if (resUnits == null)
+			return null;
+		List<ResourceUnit> values = new ArrayList<ResourceUnit>();
+		Collection<List<ResourceUnit>> lists = resUnits.values();
+		Iterator<List<ResourceUnit>> itr = lists.iterator();
+
+		while (itr.hasNext()) {
+			List<ResourceUnit> list = itr.next();
+			values.addAll(list);
+		}
+
+		return values;
+	}
+
+	public Map<ResourceUnitName, List<ResourceUnit>> getResourceUnits() {
+		return resUnits;
 	}
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/description/ExecutingResourceDescription.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/description/ExecutingResourceDescription.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/description/ExecutingResourceDescription.java	(revision 1207)
@@ -1,74 +1,21 @@
 package schedframe.resources.computing.description;
 
-import java.util.ArrayList;
 import java.util.Collection;
-import java.util.HashMap;
-import java.util.Iterator;
 import java.util.List;
 import java.util.Map;
 
-import schedframe.Parameters;
-import schedframe.resources.ResourceType;
 import schedframe.resources.units.ResourceUnit;
 import schedframe.resources.units.ResourceUnitName;
 
-public class ExecutingResourceDescription extends AbstractResourceDescription {
+public interface ExecutingResourceDescription {
+	
+	public void addResourceUnit(ResourceUnit unit);
+	
+	public ResourceUnit getResourceUnit(ResourceUnitName unitName) throws NoSuchFieldException ;
 
-	protected Map<ResourceUnitName, List<ResourceUnit>> resUnits;
-	protected Parameters parameters;
+	public List<ResourceUnit> getResourceUnitList(ResourceUnitName unitName) throws NoSuchFieldException;
+
+	public Collection<ResourceUnit> getResourceUnit();
 	
-	public ExecutingResourceDescription(ResourceType type) {
-		super(type);
-	}
-
-	public Parameters getParameters() {
-		return parameters;
-	}
-	
-	public String getCompResourceParameterValue(String name){
-		return getParameters().get(name).get(0).getContent();
-	}
-	
-	public void addResourceUnit(ResourceUnit unit) {
-		if (this.resUnits == null)
-			this.resUnits = new HashMap<ResourceUnitName, List<ResourceUnit>>(1);
-		List<ResourceUnit> list = null;
-		if (this.resUnits.containsKey(unit.getName())) {
-			list = this.resUnits.get(unit.getName());
-		} else {
-			list = new ArrayList<ResourceUnit>(1);
-			this.resUnits.put(unit.getName(), list);
-		}
-		list.add(unit);
-	}
-	
-	public ResourceUnit getResourceUnit(ResourceUnitName unitName) throws NoSuchFieldException {
-		return getResourceUnitList(unitName).get(0);
-	}
-
-	public List<ResourceUnit> getResourceUnitList(ResourceUnitName unitName) throws NoSuchFieldException {
-		if (resUnits.containsKey(unitName))
-			return resUnits.get(unitName);
-		else
-			throw new NoSuchFieldException("Resource unit " + unitName + " is not available in resource " + this.id);
-	}
-
-	public Collection<ResourceUnit> getResourceUnit() {
-		if (resUnits == null)
-			return null;
-		List<ResourceUnit> values = new ArrayList<ResourceUnit>();
-		Collection<List<ResourceUnit>> lists = resUnits.values();
-		Iterator<List<ResourceUnit>> itr = lists.iterator();
-
-		while (itr.hasNext()) {
-			List<ResourceUnit> list = itr.next();
-			values.addAll(list);
-		}
-
-		return values;
-	}
-
-	public Map<ResourceUnitName, List<ResourceUnit>> getResourceUnits() {
-		return resUnits;
-	}
+	public Map<ResourceUnitName, List<ResourceUnit>> getResourceUnits();
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/description/ResourceDescription.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/description/ResourceDescription.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/description/ResourceDescription.java	(revision 1207)
@@ -0,0 +1,64 @@
+package schedframe.resources.computing.description;
+
+
+import java.util.ArrayList;
+import java.util.List;
+
+import schedframe.Parameters;
+import schedframe.resources.ResourceType;
+
+
+public abstract class ResourceDescription {
+
+	protected String id;
+	protected ResourceType type;
+	protected List<ResourceDescription> children;
+	protected Parameters parameters;
+	
+	public ResourceDescription(ResourceType type){
+		this.type = type;
+	}
+
+	public List<ResourceDescription> getChildren() {
+		return children;
+	}
+	
+	public void setChildren(List<ResourceDescription> children) {
+		this.children = children;
+	}
+	
+	public void addChildren(ResourceDescription child) {
+		//child.setParent(this);
+		if(children == null)
+			children = new ArrayList<ResourceDescription> (1);
+		this.children.add(child);
+	}
+
+	public String getId(){
+		return this.id;
+	}
+
+	public ResourceType getType() {
+		return type;
+	}
+	
+	public Parameters getParameters() {
+		return parameters;
+	}
+	
+	/*protected AbstractResourceDescription parent;
+	/public AbstractResourceDescription getParent() {
+		return parent;
+	}
+
+	public void setParent(AbstractResourceDescription parent) {
+		this.parent = parent;
+	}*/
+	
+	/*public enum ResourceType {
+		COMPUTING_RESOURCE,
+		QUEUING_SYSTEM;
+	}
+	*/
+	
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PState.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PState.java	(revision 1119)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PState.java	(revision 1207)
@@ -1,3 +1,6 @@
 package schedframe.resources.computing.profiles.energy.power;
+
+import java.util.Map;
+import java.util.TreeMap;
 
 public class PState {
@@ -9,5 +12,7 @@
 	protected double powerUsageMin;
 	protected double powerUsageMax;
-
+	//protected List<LoadPowerUsage> loadPowerUsageList;
+	protected Map<Double, Double> loadPowerUsage;
+	
 	/*public PState(PStateType name, double frequency, double voltage, double power) {
 		super();
@@ -38,5 +43,14 @@
 		return powerUsageMax;
 	}
-	
+	/*public List<LoadPowerUsage> getLoadPowerUsageList() {
+		return loadPowerUsageList;
+	}*/
+	public Map<Double, Double> getLoadPowerUsage() {
+		if(loadPowerUsage == null) {
+			return new TreeMap<Double, Double>();
+		}
+		return loadPowerUsage;
+	}
+
 	public static class Builder {
 	  
@@ -47,4 +61,6 @@
 		protected double powerUsageMin;
 		protected double powerUsageMax;
+		//protected List<LoadPowerUsage> loadPowerUsageList = new ArrayList<LoadPowerUsage>();
+		protected Map<Double, Double> loadPowerUsage = new TreeMap<Double, Double>();
 		
 		public Builder name(String name){this.name = name; return this; }
@@ -54,4 +70,6 @@
         public Builder powerUsageMin(double rate){this.powerUsageMin = rate; return this; }
         public Builder powerUsageMax(double rate){this.powerUsageMax = rate; return this; }
+        //public Builder loadPowerUsage(LoadPowerUsage lpu){this.loadPowerUsageList.add(lpu); return this; }
+        public Builder loadPowerUsage(double load, double power){this.loadPowerUsage.put(load, power); return this; }
         
         public PState build() {
@@ -67,4 +85,8 @@
 		this.powerUsageMin = builder.powerUsageMin;
 		this.powerUsageMax = builder.powerUsageMax;
+		//this.loadPowerUsageList = builder.loadPowerUsageList;
+		this.loadPowerUsage = builder.loadPowerUsage;
 	}
+
+
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/LoadPowerUsage.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/LoadPowerUsage.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/LoadPowerUsage.java	(revision 1207)
@@ -0,0 +1,20 @@
+package schedframe.resources.computing.profiles.energy.power;
+
+public class LoadPowerUsage {
+	double load;
+	double powerUsage;
+	
+	public LoadPowerUsage(double load, double powerUsage) {
+		super();
+		this.load = load;
+		this.powerUsage = powerUsage;
+	}
+
+	public double getLoad() {
+		return load;
+	}
+
+	public double getPowerUsage() {
+		return powerUsage;
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerInterfaceFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerInterfaceFactory.java	(revision 1104)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/PowerInterfaceFactory.java	(revision 1207)
@@ -1,44 +1,38 @@
 package schedframe.resources.computing.profiles.energy.power;
 
-import schedframe.resources.CoolEmAllResourceType;
 import schedframe.resources.StandardResourceType;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
+import schedframe.resources.devices.PhysicalResource;
+import schedframe.resources.devices.PhysicalResourcePowerInterface;
 
 public class PowerInterfaceFactory {
 
-
-
-	//new1
-	/*public static PowerInterface createPowerProfile(ResourceType resourceType, List<PowerState> powerStates, List<PState> pStates, String eepn){
-
-		PowerInterface powerProfile;
-
-		switch(resourceType){
-			case DataCenter: powerProfile = new DataCenterPowerInterfaceNew(eepn, powerStates); break;
-			case ComputingNode: powerProfile = new ComputingNodePowerInterfaceNew(eepn, powerStates); break;
-			case Processor: powerProfile = new CPUPowerInterfaceNew(eepn, powerStates, pStates); break;
-			default:
-				throw new IllegalArgumentException("ResourceType " + resourceType + " is not supported.");
-		}
-
-		return powerProfile;
-	}*/
 	
-	public static PowerInterface createPowerInterface(ComputingResource resource, PowerProfile pp){
+	public static PowerInterface createPowerInterface(PhysicalResource resource, PowerProfile pp){
 		if(pp == null)
 			return null;
 		PowerInterface powerInterface;
-
+		
 		if(resource.getType().getName().equals(StandardResourceType.DataCenter.getName()))
-			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.DataCenterPowerInterface(resource, pp);
-		else if (resource.getType().getName().equals(StandardResourceType.ComputingNode.getName()))
-			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ComputingNodePowerInterface(resource, pp);
+			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.DataCenterPowerInterface((ComputingResource)resource, pp);
+		else if (resource.getType().getName().equals(StandardResourceType.Node.getName()))
+			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ComputingNodePowerInterface((ComputingResource)resource, pp);
 		else if (resource.getType().getName().equals(StandardResourceType.Processor.getName()))
-			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ProcessorPowerInterface(resource, pp);
-		else if (resource.getType().getName().equals(CoolEmAllResourceType.Node.getName()))
-			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ComputingNodePowerInterface(resource, pp);
+			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ProcessorPowerInterface((ComputingResource)resource, pp);
+		else if (resource.getType().getName().equals(StandardResourceType.CRAH.getName()))
+			powerInterface = new PhysicalResourcePowerInterface(resource, pp);
+		else if (resource.getType().getName().equals(StandardResourceType.Fan.getName()))
+			powerInterface = new PhysicalResourcePowerInterface(resource, pp);
+		else if (resource.getType().getName().equals(StandardResourceType.Inlet.getName()))
+			powerInterface = new PhysicalResourcePowerInterface(resource, pp);
+		else if (resource.getType().getName().equals(StandardResourceType.Outlet.getName()))
+			powerInterface = new PhysicalResourcePowerInterface(resource, pp);
+		else if (resource.getType().getName().equals(StandardResourceType.CoolingDevice.getName()))
+			powerInterface = new PhysicalResourcePowerInterface(resource, pp);
+		else if (resource.getType().getName().equals(StandardResourceType.Heatsink.getName()))
+			powerInterface = new PhysicalResourcePowerInterface(resource, pp);
 		else 
-			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ComputingResourcePowerInterface(resource, pp);
+			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ComputingResourcePowerInterface((ComputingResource)resource, pp);
 
 		/*switch(resource.getType()){
